#!/bin/bash
# Copyright 2009 - 2018 Michal Žejdl
# run all the components

# dependencies
for program in mv mkfifo mysql touch pgrep
do
	which "$program" >/dev/null || exit
done

confdir=$(dirname $0)
config=$confdir/defaults.sh
test -f $config || exit
source $config

for golem in $golems
do
	pidfile="$rundir/$golem.pid"

	test -f "$pidfile" || continue

	pid_from_pidfile=$(<"$pidfile")

	# pidof searches for bash but not the golems
	for running_pid in $(pgrep "$golem")
	do
		if test "$running_pid" = "$pid_from_pidfile"
		then
			echo "it looks like another instance of nana is running"
			echo "(pid $running_pid golem $golem)"
			echo "please try to stop it first"
			exit 1
		fi
	done
done

# create the named pipe
test -e "$mysqlwpipe" || mkfifo "$mysqlwpipe"
test -p "$mysqlwpipe" || exit

for golem in $golems
do
	# create a "šém" for the golem
	touch "$rundir/$golem.sem"

	# a consolidate start of a golem; the golem must be the file name
	case "$golem" in
	dbpipe.sh)
		"$coredir/$golem" \
			>>"$logdir/$golem.out" 2>>"$logdir/$golem.err" \
			& echo "$!" >"$rundir/$golem.pid"
		;;
	esac
done

# pid file creation removed; (... /revisor.err & echo $! > $rundir/revisor.pid)
$netldbdir/revisor.sh >> $logdir/revisor.out 2>> $logdir/revisor.err &
$netldbdir/snmp/dispatcher.sh >> $logdir/dispatcher.out 2>> $logdir/dispatcher.err &

$coredir/fdb2graph.sh >>$logdir/fdb2graph.out 2>>$logdir/fdb2graph.err &
$coredir/rresolver.sh >> $logdir/rresolver.out 2>> $logdir/rresolver.err &
$coredir/topology.sh >> $logdir/topology.out 2>> $logdir/topology.err &
$coredir/snmp/addresses.sh >> $logdir/snmp/addresses.out 2>> $logdir/snmp/addresses.err &
$coredir/snmp/agents.sh >> $logdir/snmp/agents.out 2>> $logdir/snmp/agents.err &
$coredir/snmp/dispatcher.sh >> $logdir/snmp/dispatcher.out 2>> $logdir/snmp/dispatcher.err &
