#!/bin/bash
# Copyright 2009 - 2018 Michal Žejdl
# opposed actions in reverse order according to start.sh

# dependencies
for program in rm ps grep wc cat mv pidof
do
	which "$program" >/dev/null || exit
done

confdir=$(dirname $0)
config=$confdir/defaults.sh
test -f $config || exit
source $config

# remove "šém" from each golem
for sem in $golems; do
	rm $rundir/$sem.sem
done

working="yes"
while test $working = "yes"
do
	working="check"
	for golem in $golems
	do
		case "$golem" in
		dbpipe.sh)
			if pidof -s "$golem" >/dev/null
			then
				working="yes"
				echo "golem still working ($golem)"
			fi
			;;
		*)
			if test $(ps ax | grep $golem.sh | grep -v grep | wc -l) -gt 0
			then
				working="yes"
				echo "golem still working ($golem)"
			fi
		esac
	done
	# an extra sleep do not hurt us if golems are not working
	sleep 1
done

pid=$(cat $rundir/mysql.pid)

# it looks like mysql stops itself after closing last filedescriptor
#kill $pid

while test $(ps ax | grep ^[[:space:]]*$pid[[:space:]] | grep -v grep | wc -l) -gt 0; do
	echo "waiting for mysql (collectors possibly still running)"
	sleep 1
done

rm $rundir/mysql.pid

# clean up the pid files
for golem in $golems
do
	pidfile="$rundir/$golem.pid"
	test -e "$pidfile" && rm "$pidfile"
done

rm $mysqlwpipe
