#!/bin/bash
# Copyright 2009, 2014, 2015 Michal Žejdl
# invoke scripts which update tables peer and uplink (network topology)

confdir=$(dirname $0)
config=$confdir/defaults.sh
test -f $config || exit
. $config

delay=90
switch=0

while true; do
	if test $switch -eq 0; then
		echo "$(date +'%F %T') $(basename $0): refresh_uplinks.sh"
  		nice -19 $netldbdir/refresh_uplinks.sh
	else
		echo "$(date +'%F %T') $(basename $0): refresh_peers.sh"
		nice -19 $netldbdir/refresh_peers.sh
	fi
	switch=$((-1 * (switch - 1)))

	echo "$(date +'%F %T') $(basename $0): sleeping $delay seconds"
	for ((i = 1; i <= $delay; i++)); do
	  	# stop this golem if "šém" is removed
		test -e $rundir/$(basename $0 .sh).sem || exit
		sleep 1
	done
done
