#!/bin/bash
# Copyright 2019 Michal Žejdl
# move to new user config in /etc/opt/nana/core/conf.sh

mydir=$(dirname $0)
coredir="$mydir/../../core"
userconfdir="/etc/opt/nana/core"
defaults="$coredir/defaults.sh"
conf_example="$coredir/conf.sh-example"
oldconfig="$coredir/conf.sh"
newconfig="$userconfdir/conf.sh"

# exit if $newconfig already exists
test -e "$newconfig" && exit

# make a directory for $newconfig
test -d "$userconfdir" || mkdir -p "$userconfdir" || exit

if test -f "$oldconfig"
then
	mv "$oldconfig" "$newconfig"
elif test -f "$conf_example"
then
	cp -a "$conf_example" "$newconfig"
else
	echo "both $oldconfig and $conf_example not found"
	exit 1
fi
