#include "input.h"

#include "../lib/db.h"

// printf()
#include <stdio.h>

// sleep()
#include <unistd.h>

// free()
#include <stdlib.h>

// LONG_MAX
//#include <limits.h>

// str*()
#include <string.h>

// get the time of the oldest live agent
time_t get_start_time(void)
{
	char q_count[] = "select count(*) from mibfdbport";
	char q_oldest[] = "select time from mibfdbport order by time limit 1";
	char *string;
	long long count;
	time_t rtime;

	do {
		// loop until we get the answer (data)
		while (! (string = db_get_one(q_count)))
			// do not disturb a database in case of error
			sleep(10);

		count = atoll(string);
		free(string);

		// wait until there is at least one row in the table
	} while (count < 1);

	// wait for the answer, do not push too hard
	while (! (string = db_get_one(q_oldest)))
		sleep(10);

	rtime = atoll(string);
	free(string);

	return rtime;
}

MYSQL_RES *get_data(time_t from, time_t till)
{
	char q_begin[] = "select agent, port, mac, time from mibfdbport where";
	// space for LONG_MAX
	char q_cond[] = " time >= 9223372036854775807 and time <= 9223372036854775807 ";
	char q_end[] = "order by time";
	char query[strlen(q_begin) + strlen(q_cond) + strlen(q_end) + 1];

	// optimize the query
	if (from == till)
		sprintf(query, "%s time = %ld %s\n", q_begin, from, q_end);
	else
		sprintf(query, "%s time >= %ld and time <= %ld %s\n",
				q_begin, from, till, q_end);

	//printf("query: %s\n", query);

	return db_query_store(query);
}
