#include "queue.h"

#include "common.h"
#include "list.h"
#include "log.h"

// malloc()
#include <stdlib.h>

struct queue *queue_init(void)
{
	struct queue *queue;
	queue = malloc(sizeof(struct queue));
	if (queue != NULL) {
		queue->arp = malloc(sizeof(struct list));
		if (queue->arp != NULL) {
			queue->nd = malloc(sizeof(struct list));
			if (queue->nd != NULL) {
				list_init(queue->arp);
				list_init(queue->nd);
				return queue;
			} else {
				log_print_time();
				fputs("malloc() failed\n", logfile);
			}
			free(queue->arp);
		} else {
			log_print_time();
			fputs("malloc() failed\n", logfile);
		}
		free(queue);
	} else {
		log_print_time();
		fputs("malloc() failed\n", logfile);
	}
	return NULL;
}

void queue_destroy(struct queue *queue)
{
	list_delete_all(queue->arp);
	list_delete_all(queue->nd);
	free(queue->arp);
	free(queue->nd);
	free(queue);
}

void queue_shrink(struct queue *queue, int maximum, int desired)
{
	list_shrink(queue->arp, maximum, desired);
	list_shrink(queue->nd, maximum, desired);
}
