<?php

/*
 * Copyright 2016 - 2018 Michal Žejdl
 */

$document_root = "../..";

require "$document_root/init.php";

$title = "MikroTik MIBs";

page_open($document_root, $title);


// enable debug_print()
//$debug = true;

// init db
$connection = mysql_connect($dbhost, $dbuser, $dbpass);
if (!$connection) exit;
mysql_select_db($dbname);

if (isset($_GET["agent"])) {
	$snmpagentid = $_GET["agent"];
	// validity check
	if (!preg_match("/^[[:digit:]]+$/", $snmpagentid)) exit;

	/*
	// start is not required
	if (isset($_GET["start"]) 
			and preg_match("/^[[:alnum:]-]+$/", $_GET["start"]))
		$start = $_GET["start"];
	// PHP automagicaly initializes variables from URL
	else unset($start);
	
	// end is not required
	if (isset($_GET["end"])
			and preg_match('/^[[:alnum:]-]+$/', $_GET["end"]))
		$end = $_GET["end"];
	else unset($end);
	*/

	print_snmp_header($document_root, $snmpagentid);

	echo "<h2>$title</h2>\n";

	/*
	// the form above tests $end presence; now we can initialize it
	if (!isset($end)) $end = "now";
	*/

	// common variables for RRD graphs
	$thisdir = dirname(__FILE__);
	$bindir = $thisdir . "/../../bin";
	$outputdir = "imgcache/" . $snmpagentid;
	if (!is_dir($outputdir))
		if (!mkdir($outputdir, 0777, true))
			exit("<p>mkdir($outputdir) failed");

	$mibnodes = array("mtxrWlStat", "mtxrWlAp", "mtxrHealth");

	/*
	 * to be used after April 2019
	$mibnodes = array("mtxrWlStat", "mtxrWlAp", "mtxrHealth",
			"mtxrHlTemperature", "mtxrHlVoltage",
			"mtxrWlApClientCount", "mtxrWlStatStrength");
	*/

	/*
	if (isset($start)) $starts = array($start);
	else $starts = array("now-1d", "now-1w", "now-1m", "now-1y");
	*/

	$end = get_end();
	$start = get_start($end);
	print_start_end_selector($start, $end);

	foreach ($mibnodes as $mibnode) {

		$rrdfile = "snmpagent/" . $snmpagentid .
			"/MikroTik/" . $mibnode . ".rrd";

		$filename = $rrdbasedir . "/" . $rrdfile;

		if (!file_exists($filename))
			continue;

		if (is_rrd_obsolete($filename, $start))
			continue;

		switch ($mibnode) {
			case "mtxrWlStat":
				$datasources = array("Strength");
				break;
			case "mtxrWlAp":
				$datasources = array("ClientCount");
				break;
			case "mtxrHealth":
				$datasources = array("Voltage", "Temperature");
				break;
			case "mtxrHlTemperature":
				$datasources = array();
				$title = "Temperature";
				$vlabel = "°C";
				$modify = "-tenth";
				break;
			case "mtxrHlVoltage":
				$datasources = array();
				$title = "Voltage";
				$vlabel = "V";
				$modify = "-tenth";
				break;
			case "mtxrWlApClientCount":
				$datasources = array();
				$title = "ApClientCount";
				$vlabel = "count";
				$modify = "";
				break;
			case "mtxrWlStatStrength":
				$datasources = array();
				$title = "Strength";
				$vlabel = "dBm";
				$modify = "";
				break;
		}

		if (empty($datasources)) {

			//foreach ($starts as $start) {
			$command = "$bindir/graph$modify-blue-line.sh"
				. " $rrdbasedir $rrdfile"
				. " $thisdir/$outputdir $start $end"
				. " $title $vlabel";
			if (! empty($rrdcached))
				$command .= " $rrdcached";
			debug_print($command);
			exec($command);
			//}

		} else {

			//foreach ($starts as $start) {
			$command = "$bindir/graph-mikrotik-$mibnode.sh"
				. " $rrdbasedir $rrdfile"
				. " $thisdir/$outputdir $start $end";
			if (! empty($rrdcached))
				$command .= " $rrdcached";
			debug_print($command);
			exec($command);
			//}
		}

		echo "<h3>$mibnode</h3>\n";

		if (empty($datasources)) {

			echo "<p class=\"center\">\n";

			//foreach ($starts as $start) {
			echo "<img alt=\"$mibnode\"",
			     " src=\"$outputdir/",
			     "$mibnode",
			     "-$start-$end.png\">";
			echo "<br>\n";
			//}

		} else {

			foreach ($datasources as $datasource) {

				echo "<h4>$datasource</h4>\n";

				echo "<p class=\"center\">\n";

				//foreach ($starts as $start) {
				echo "<img alt=\"$datasource\"",
				     " src=\"$outputdir/mikrotik",
				     "-$mibnode-$datasource",
				     "-$start-$end.png\">";
				echo "<br>\n";
				//}

			}
		}
	}

} else {
	// agent is not set - show all live agents

	echo "<h1>";
	echo gettext("all known recently live MikroTik devices");
	echo "</h1>\n";

	if (isset($_GET["order"]))
		$order = $_GET["order"];
	else $order = "name";

	switch ($order) {
		case "name":
			$order_by = "sysName";
			break;
		case "time":
			$order_by = "time";
			break;
		case "board_name":
			$order_by = "board_name";
			break;
		case "ros_version":
			$order_by = "ros_version";
			break;
		default:
			$order_by = "sysName";
	}

	//$debug = true;
	debug_print("$order_by");
	$result = mysql_query("select
			sysName, agent, entPhysical.time time,
			substring_index(entPhysicalDescr, ' on ', 1)
			ros_version,
			substring_index(entPhysicalDescr, ' on ', -1)
			board_name
			from snmpagent join entPhysical on id = agent
			where
			sysObjectID = '.1.3.6.1.4.1.14988.1'
			and entPhysical.time > unix_timestamp() - 7 * 86400
			and entPhysicalClass = 3
			order by $order_by");

	//$debug = true;

	echo "<table summary=\"", gettext("MikroTik devices"), "\">\n";
	$anchor = "<a href=\"?order=";
	echo "<tr>",
	     "<th>", $anchor, "name", "\">", "sysName",
	     "<th>", $anchor, "time", "\">", "time",
	     "<th>", $anchor, "board_name", "\">", "Board Name",
	     "<th>", $anchor, "ros_version", "\">", "RouterOS version",
	     "\n";

	$row_number = 0;
	$timestamp = time();

	while ($row = mysql_fetch_array($result)) {
		echo "<a name=\"", $row["agent"], "\"></a>";
		echo "<tr class=\"monospace ",
		     tr_aging_class(++$row_number, $timestamp - $row["time"]),
		     "\">";
		echo "<td>";
		print_link_to_agent("MikroTik.php?agent=", $row["agent"],
				$row["sysName"]);
		echo "<td>", date_formated($row["time"]),
		     "<td>", $row["board_name"],
		     "<td>",
		     $row["ros_version"],
		     "\n";
	}
	echo "</table>\n";

	echo "<h2>", gettext("legend"), "</h2>\n";

	echo "<p>", gettext("columns are sorted by click on their names"), "\n";

	echo "<ul>\n";
	echo "<li>sysName - ", gettext("system MIB entry"), "\n";
	echo "<li>time - ", gettext("time of reading the entity MIB"), "\n";
	echo "<li>Board Name - ", gettext("end of entPhysicalDescr"), "\n";
	echo "<li>RouterOS version - ", gettext("start of entPhysicalDescr"),
	     "\n";
	echo "</ul>\n";

}



page_close($document_root);

?>
